//<html><pre>
/* ----------------------------------------------------------------------------------------------
    transistor.java		gWX^						ver. 1.00 (JDK 1.02)
    														ueyama@infonet.co.jp  1999.03.26
---------------------------------------------------------------------------------------------- */

import java.applet.Applet;
import java.awt.*;
import java.lang.Math;
import java.util.*;

public class transistor extends Applet implements Runnable
{
	int			Ib=0;												// x[Xd
	int			Sw=0;												// RN^ SW  0:OFF 1:ON
	int			Wait=128;											// \ύX҂ (msec)
	int			Ex[]=new int[128], Ey[]=new int[128];				// G~b^dqʒuW
	int			Cx[]=new int[80], Cy[]=new int[80];					// RN^dqʒuW
	int			Bx[]=new int[80], By[]=new int[80];					// x[XEʒuW
	int			Qe0, Qb0, Qc0;										// dqEE
	int			Qem, Qbm;											// dqEEڕW
	int			Qtye, Qtyc, Qtyb;									// dqEE
	boolean		Run=true;
	boolean		Er[]=new boolean[128], Cr[]=new boolean[80], Br[]=new boolean[80];
	boolean		Ec[]=new boolean[128];
	Image		Gif;
	Image		buf=null;
	Thread		th=null;
	int			R,G,B;
	Random		Rnd=new Random();
	int			Rt=8;
	
	public void init()
	{
		R=Integer.parseInt(getParameter("bg_red"));
		G=Integer.parseInt(getParameter("bg_green"));
		B=Integer.parseInt(getParameter("bg_blue"));
		setBackground(new Color(R,G,B));
		
		MediaTracker mt=new MediaTracker(this);
		Gif=getImage(getCodeBase(),"npn_tr.gif");
		mt.addImage(Gif, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
		buf=createImage(size().width,size().height);
		Qem=Qtye=Qe0=16; Qbm=Qtyb=Qb0=6; Qtyc=Qc0=16;				// dqEE
		carrier_initialize();
	}
	
	public void start()
	{
		if(th==null)
		{
			th=new Thread(this);
			th.start();
		}
	}
	
	public boolean inside(int x, int a, int b)
	{
		return (x<=Math.max(a,b) && x>=Math.min(a,b)) ? true:false;
	}
	
	public void carrier_initialize()								// dqEȄzu
	{
		int i,j,k,m,x,y;
		
		for(i=0;i<Qe0;i++)											// 20sNZx̕Uzu
		{
			while(true)												// G~b^̓dq
			{
				x=Math.abs(Rnd.nextInt())%122+60;
				y=Math.abs(Rnd.nextInt())%90+103;
				for(j=0;j<i;j++) if((x-Ex[j])*(x-Ex[j])+(y-Ey[j])*(y-Ey[j])<400) break;
				if(j==i || i==0)
				{
					Ex[i]=x;Ey[i]=y;
					break;
				}
			}
			while(true)												// RN^̓dq
			{
				x=Math.abs(Rnd.nextInt())%122+222;
				y=Math.abs(Rnd.nextInt())%90+103;
				for(j=0;j<i;j++) if((x-Cx[j])*(x-Cx[j])+(y-Cy[j])*(y-Cy[j])<400) break;
				if(j==i || i==0)
				{
					Cx[i]=x;Cy[i]=y;
					break;
				}
			}
			Er[i]=true; Cr[i]=true;
		}
		
		for(i=0;i<Qb0;i++)											// 16sNZx̕Uzu
		{
			while(true)
			{
				x=Math.abs(Rnd.nextInt())%22+190;
				y=Math.abs(Rnd.nextInt())%90+103;
				for(j=0;j<i;j++) if((x-Bx[j])*(x-Bx[j])+(y-By[j])*(y-By[j])<256) break;
				if(j==i || i==0)
				{
					Bx[i]=x;By[i]=y;
					break;
				}
			}
			Br[i]=true;
		}
		Qem=Qtye=Qe0; Qbm=Qtyb=Qb0; Qtyc=Qc0;						// dq
		for(i=0;i<128;i++) Ec[i]=true;
	}
	
	public void carrier_qty_set()
	{
		if(Ib>0)
		{
			Qem=Qe0*((Sw==1)?3:2)*(Ib+1)/2;
			Qbm=Qb0*2*(Ib+1)/2;
		}
		else
		{
			Qtyc=Qc0; Qtye=Qem=Qe0; Qtyb=Qbm=Qb0;
		}
	}
	
	public int move_x()												// dqEE̐is
	{
		int x=Math.abs(Rnd.nextInt())%100;
		if(x<8) return 0;
		else if(x<16) return 1;
		else if(x<32) return 2;
		else if(x<64) return 3;
		else return 4;
	}
	
	public int move_y()												// dqEE̗h
	{
		int x=Math.abs(Rnd.nextInt())%100;
		if(x<10) return 2;
		else if(x<20) return 1;
		else if(x<30) return -1;
		else if(x<40) return -2;
		else return 0;
	}
	
	public int new_electron(int y, int n, int dis)					// dq̋
	{
		int i,j=0,x=105;
		
		for(i=0;i<Rt;i++)
		{
			while(!inside(y+=move_y(),103,194));
			for(j=0;j<Qtye;j++) if((x-Ex[j])*(x-Ex[j])+(y-Ey[j])*(y-Ey[j])<dis && n!=j) break;
			if(j==Qtye) break;
		}
		return (j==Qtye)? y:0;
	}
	
	public int new_hole(int i)										// E̋
	{
		int j,k=0, x=0,y=202;
		
		for(j=0;j<Rt;j++)
		{
			x=Math.abs(Rnd.nextInt())%23+190;
			for(k=0;k<Qtyb;k++) if((x-Bx[k])*(x-Bx[k])+(y-By[k])*(y-By[k])<64 && i!=k) break;
			if(k==Qtyb) break;
		}
		return (k==Qtyb)? x:0;
	}

	public int move_hole(int i, boolean m)							// Ëړ
	{
		int j,k, x,y;
		
		for(k=0, j=0;j<Rt;j++)
		{
			x=Bx[i]-move_x();
			y=(m)? By[i]-move_x()*3/8: move_y()/2+By[i];
			for(k=0;k<Qtyb;k++) if((x-Bx[k])*(x-Bx[k])+(y-By[k])*(y-By[k])<64 && k!=i) break;
			if(( m && k==Qtyb && inside(x,52,213) && inside(y,103,202)) || 
	 		  ((!m && k==Qtyb && inside(y,103,194)) && (inside(x,60,182) || inside(x,190,213))))				{
				Bx[i]=x;By[i]=y;
				break;
			}
		}
		return k;
	}

	public void move_ec(int i)
	{
		int j,k, x,y;
		
		for(j=0;j<Rt;j++)											// dq̏Փ˂
		{
			x=move_x()+Cx[i];
			y=move_y()/2+Cy[i];
			for(k=0;k<Qtyc;k++)
				if((x-Cx[k])*(x-Cx[k])+(y-Cy[k])*(y-Cy[k])<64 && k!=i && Cr[k]) break;
			if(k==Qtyc && inside(x,181,343) && inside(y,103,194))
			{
				Cx[i]=x; Cy[i]=y;
				break;
			}
		}
	}

	public void move_ee(int i)
	{
		int j,k, x,y;
		
		for(j=0;j<Rt;j++)
		{
			x=move_x()+Ex[i];
			y=move_y()/2+Ey[i];
			for(k=0;k<Qtye;k++)
				if((x-Ex[k])*(x-Ex[k])+(y-Ey[k])*(y-Ey[k])<64 && k!=i && Er[k]) break;
			if(k==Qtye && inside(x,60,181) && inside(y,103,194))
			{
				Ex[i]=x; Ey[i]=y;
				break;
			}
		}
	}

	public void move_eel(int i)
	{
		int j,k=0, x,y;
		
		for(j=0;j<Rt;j++)
		{
			x=move_x(); if(Sw==0) x/=2;
			x+=Ex[i];
			y=move_y()/2+Ey[i]+(inside(x,190,213) ? move_x():0);
			for(k=0;k<Qtye;k++) if((x-Ex[k])*(x-Ex[k])+(y-Ey[k])*(y-Ey[k])<64 && k!=i) break;
			if(k==Qtye && inside(x,52,(Sw==1)?351:213) && inside(y,103,(x>190)?202:194))
			{
				Ex[i]=x; Ey[i]=y;
				break;
			}
		}
		if(k<Qtye && Ib>0)
		{
			if(inside(Ex[k],190,213)) Ey[k]+=Math.abs(move_y());
			else if(inside(Ex[k],52,351)) Ex[k]+=Math.abs(move_y());
		}
		if(inside(Ex[i],213,343) && Ey[i]>194) Ey[i]--;
	}

	public void carrier_ec()
	{
		int i,j,k,x,y;
		
		for(i=0;i<Qtyc;i++) if(Cr[i]) move_ec(i);					// RN^̓dq
		if(Ib==0)
		{
			for(i=0;i<Qtye;i++) move_ee(i);							// G~b^̓dq
			for(i=0;i<Qtyb;i++)										// x[X̐E
			{
				move_hole(i, false);
				if(By[i]>194) By[i]--;
			}
		}
	}
	
	public void carrier_eb()
	{
		int i,j,k=0,m=0,x=0,y=0;
		
		if(Qtye>Qem) Qtye=Qem;
		else
		{
			for(i=0,j=0; i<Qtye; i++) if(Er[i]) j++;
			if(j==0)
			{
				for(i=Qtye; i<Qem; i++)
				{
					y=Math.abs(Rnd.nextInt())%90+103;
					m=new_electron(y,i,170);
					Ey[i]=(m>0)? m:y;	Ex[i]=52; 
					Er[i]=false; Qtye++;
				}
			}
		}
		
		if(Qtyb>Qbm) Qtyb=Qbm;
		else
		{
			for(i=0,j=0; i<Qtyb; i++) if(Br[i]) j++;
			if(j==0)
			{
				for(i=Qtyb; i<Qbm; i++)
				{
					x=Math.abs(Rnd.nextInt())%23+190;
					m=new_hole(i);
					Bx[i]=(m>0)? m:x;	By[i]=203;
					Br[i]=false; Qtyb++;
				}
			}
		}
		
		for(i=0;i<Qtyb;i++)											// x[X̐E
		{
			k=move_hole(i, true);
			if(Bx[i]<188 && Br[i])									// G~b^̈ɓ
			{
				m=new_hole(i);
				if(m>0)
				{
					Bx[Qtyb]=m; By[Qtyb]=203; Br[Qtyb]=false;
					Br[i]=false; Qtyb++;
				}
			}
			if(k<Qtyb && Ib>0)
			{
				if(By[k]>120) By[k]-=Math.abs(move_y())*3;
				else		  By[k]+=Math.abs(move_y())*3;
			}
			if(inside(Bx[i],60,185) && By[i]>194) By[i]--;

			if(Bx[i]<=55)											// G~b^dɂɓB
			{
				x=Math.abs(Rnd.nextInt())%23+190;
				m=new_hole(i);
				Bx[i]=(m>0)? m:x;
				By[i]=203;
			}
		}
		
		for(i=0;i<Qtye;i++)											// G~b^̓dq
		{
			move_eel(i);
			
			if(Ex[i]>182 && Er[i])									// x[Ẍɓ
			{
				m=new_electron(Ey[i],i,170);
				Ey[Qtye]=(m>0)? m:Ey[i];
				Ex[Qtye]=52; Er[Qtye]=false; 
				Er[i]=false; Qtye++;
			}
			if(Ey[i]>=201)											// x[XdɂɓB
			{
				y=Math.abs(Rnd.nextInt())%90+103;
				m=new_electron(y,i,170);
				Ey[i]=(m>0)? m:y;
				Ex[i]=52; 
			}
			if(Ex[i]>214 && Ec[i])									// RN^̈ɓ
			{
				x=0; m=0;
				for(j=0;j<Qtyc;j++)									// ł̓dqI
				{
					if(Cx[j]>x && Cr[j]) {x=Cx[j]; m=j;}
				}
				if(x>0)												// G~b^̓dqƂĈ
				{
					Cr[m]=false; Ec[i]=false;
					Ex[Qtye]=Cx[m]; Ey[Qtye]=Cy[m]; Er[Qtye]=false; Ec[Qtye]=false;
					Qtye++;
				}
			}
			if(Ex[i]>=351)											// RN^dɂɓB
			{
				y=Math.abs(Rnd.nextInt())%90+103;
				m=new_electron(y,i,170);
				Ey[i]=(m>0)? m:y;
				Ex[i]=52;
			}
	//		showStatus("Qtye="+Qtye+",  Qtyb="+Qtyb+",  Qem="+Qem+",  Qbm="+Qbm);	// --------
		}
	}
	
	public void dsp_m(int n, int f, int d, Graphics g)				// HL̕\
	{																// d=0:V{z  1:c
		int			x=0,y=0, w=0,h=0, ox=0,oy=0;
		Graphics	gx=g.create();
		switch(n)
		{
			case  0: x=418; y= 56; w=69; h=69; ox=  0; oy=307; break;	// d
			case  1: x=218; y=222; w=46; h=46; ox=276; oy=307; break;	// d
			case  2: x=298; y=  4; w=55; h=32; ox=460; oy=307; break;	// XCb`
			case  3: x=149; y=277; w= 9; h=17; ox=276; oy=353; break;	// x[Xdl
			case  4: x=118; y=274; w=26; h=23; ox=515; oy=215; break;	// x[Xd{^
			case  5: x=163; y=274; w=26; h=23; ox=515; oy=146; break;	// x[Xd{^
			case  6: x=457; y=274; w=26; h=23; ox=515; oy=284; break;	// ꎞ~{^
			case  7: x=457; y=274; w=26; h=23; ox=515; oy=330; break;	// ĊJ{^
			case  8: x=362; y=161; w=31; h=31; ox=510; oy= 22; break;	// {}[N
			case  9: x= 18; y=161; w=31; h=31; ox=510; oy= 84; break;	// |}[N
			case 10: x=423; y=274; w=26; h=23; ox=348; oy=353; break;	// ~{^
			case 11: x=181; y=214; w=15; h=15; ox=400; oy=353; break;	// {}[N ()
		}
		gx.clipRect(x,y,w,h);
		gx.drawImage(Gif,x-(ox+f*w*((d==0)?1:0)),y-(oy+f*h*d),this);
		gx.dispose();
	}
	
	public void paint(Graphics g)
	{
		int i;
		
		g.setColor(new Color(R,G,B));
		g.fillRect(0,0,size().width,size().height);
		g.drawImage(Gif,0,0,this);
		dsp_m(0,Ib*Sw,0,g);											// d`
		dsp_m(1,Ib,0,g);											// d
		dsp_m(2,Sw,1,g);											// XCb`
		dsp_m(3,Ib,0,g);											// x[Xdl
		dsp_m(4,(Ib==0)?2:0,1,g);									// x[Xd{^
		dsp_m(5,(Ib==3)?2:0,1,g);									// x[Xd{^
		dsp_m((Run)?6:7,0,1,g);										// ꎞ~ĊJ{^
		dsp_m(8,Sw,1,g);											// {}[N
		dsp_m(9,Sw,1,g);											// |}[N
		dsp_m(10,0,0,g);											// ~{^
		dsp_m(11,Ib,0,g);											// {}[N ()
		g.clipRect(60,103,291,99);
		g.setColor(new Color(51,102,255));							// dq`
		for(i=0;i<Qtye;i++) if((Ib==0 && Er[i]) || Ib>0) g.fillOval(Ex[i],Ey[i],8,8);
		for(i=0;i<Qtyc;i++) if(Cr[i]) g.fillOval(Cx[i],Cy[i],8,8);
		g.setColor(new Color(255,51,153));							// E`
		for(i=0;i<Qtyb;i++) g.fillOval(Bx[i],By[i],8,8);
	}
	
	public void run()
	{
		while(th!=null)
		{
			if(Run)
			{
				if(Sw==1)	carrier_ec();
				if(Ib>0)	carrier_eb();
			}
			Graphics offg=buf.getGraphics();
			paint(offg);
			Graphics ong=getGraphics();
			ong.drawImage(buf,0,0,this);
			try
			{
				th.sleep((Run)?Wait:500);
			}
			catch (InterruptedException e){};
		}
	}
	
	public boolean mouseDown(Event e, int x, int y)
	{
		int i,j,k;
		Graphics gb=getGraphics();
		
		if(inside(x,163,189) && inside(y,274,297) && Ib<3)			// x[Xd{^
		{
			dsp_m(5,1,1,gb);
			Ib++;
			carrier_qty_set();
		}
		if(inside(x,118,144) && inside(y,274,297) && Ib>0)			// x[Xd{^
		{
			dsp_m(4,1,1,gb);
			Ib--;
			if(Ib==0)
			{
				j=0; k=0;
				for(i=0;i<Qtyc;i++)
				{
					if(Cr[i])
					{
						Cx[j]=Cx[i]; Cy[j]=Cy[i]; Cr[j]=true; j++;
					}
				}
				for(i=0;i<Qtye;i++)
				{
					if(Ex[i]>188)
					{
						Cx[j]=Ex[i]; Cy[j]=Ey[i]; Cr[j]=true; Er[i]=false; j++;
					}
					else
					{
						Ex[k]=Ex[i]; Ey[k]=Ey[i]; Er[k]=true; Ec[k]=true; k++;
					}
				}
			}
			carrier_qty_set();
		}
		if(inside(x,298,353) && inside(y,4,36))						// XCb`
		{
			Sw=1-Sw;
			if(Sw==0 && Ib==0) carrier_initialize();
			else carrier_qty_set();
		}
		if(inside(x,457,483) && inside(y,274,297))					// ~EĊJ{^
		{
			dsp_m((Run)?6:7,1,1,gb);
			Run=!Run;
		}
		if(inside(x,423,449) && inside(y,274,297))					// ~{^
		{
			Sw=0; Ib=0; Run=true;
			carrier_initialize();
			dsp_m(10,1,0,gb);
		}
		return true;
	}

	public void stop()
	{
		if(th!=null)
		{
			th.stop();
			th=null;
		}
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</A></html>
